﻿Imports System
''' <summary>
''' [UC]マルチロー
''' </summary>
''' <remarks>
''' 
''' 更新日  ：
''' 更新内容：
''' 
''' </remarks>
Public Class UcMultirow130930

#Region "変数"

    'プロパティ用
    Private _activeRow As Control = Nothing
    Private _maxMrow As Integer = 2
    '処理用
    Private template As UserControl = Nothing

#End Region

#Region "プロパティ（新規追加）"

    <System.ComponentModel.DefaultValue("")> _
    Public Property ActiveRowIndex As String
        Get
            Return FNC_AROW_IDX_GET()
        End Get
        Set(value As String)
            FNC_AROW_IDX_SET(value)
        End Set
    End Property

    <System.ComponentModel.DefaultValue("")> _
    Public Property ActiveCellKey As String
        Get
            Return FNC_ACEL_KEY_GET(FNC_AROW_IDX_GET)
        End Get
        Set(value As String)
            FNC_ACEL_SET(FNC_AROW_IDX_GET, value)
        End Set
    End Property

    <System.ComponentModel.DefaultValue(False)> _
    Public Property FooterVisible As Boolean
        Get
            Return PNL_Footer.Visible
        End Get
        Set(value As Boolean)
            PNL_Footer.Visible = value
        End Set
    End Property

    <System.ComponentModel.DefaultValue(False)> _
    Public Property HeaderVisible As Boolean
        Get
            Return PNL_Header.Visible
        End Get
        Set(value As Boolean)
            PNL_Header.Visible = value
        End Set
    End Property

    ''' <summary>
    ''' セル値の取得・設定
    ''' </summary>
    ''' <param name="index">マルチ行インデックス</param>
    ''' <param name="cellName">セル名</param>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property Item(ByVal index As String, ByVal cellName As String) As String
        Get
            Return FNC_ITM_GET(index, cellName)
        End Get
        Set(value As String)
            FNC_ITM_SET(index, cellName, value)
        End Set
    End Property

    Public Property ItemCombo(ByVal index As String, ByVal cellName As String) As String
        Get
            Return FNC_ITM_CMB_GET(index, cellName)
        End Get
        Set(value As String)
            FNC_ITM_CMB_SET(index, cellName, value)
        End Set
    End Property

    Public Property ItemCheckBox(ByVal index As String, ByVal cellName As String) As Boolean
        Get
            Return FNC_ITM_CHK_GET(index, cellName)
        End Get
        Set(value As Boolean)
            FNC_ITM_CHK_SET(index, cellName, value)
        End Set
    End Property

    Public Property ItemRadioButton(ByVal index As String, ByVal cellName As String) As Boolean
        Get
            Return FNC_ITM_RDO_GET(index, cellName)
        End Get
        Set(value As Boolean)
            FNC_ITM_RDO_SET(index, cellName, value)
        End Set
    End Property

    ''' <summary>
    ''' フッターセル値の取得・設定
    ''' </summary>
    ''' <param name="cellName">セル名</param>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Property ItemFooter(ByVal cellName As String) As String
        Get
            Return FNC_ITM_FOT_GET(cellName)
        End Get
        Set(value As String)
            '
        End Set
    End Property

    ''' <summary>
    ''' 最大マルチ行の取得・設定
    ''' </summary>
    ''' <value></value>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <System.ComponentModel.DefaultValue(2)> _
    Public Property MaxMrow As Integer
        Get
            Return _maxMrow
        End Get
        Set(value As Integer)
            _maxMrow = value
            FNC_SET_TMP()
        End Set
    End Property

#End Region

#Region "メソッド（非公開）"

    ''' <summary>
    ''' アクティブ行名称の取得
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_AROW_IDX_GET() As String
        Dim D_RTN As String = ""
        '
        If Not IsNothing(_activeRow) Then
            D_RTN = _activeRow.Name
        End If
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' アクティブ行の設定
    ''' </summary>
    ''' <param name="index"></param>
    ''' <remarks></remarks>
    Private Sub FNC_AROW_IDX_SET(ByVal index As String)
        Dim D_OBJ As Control
        '
        If Not IsNumeric(index) Then
            Exit Sub
        End If
        '
        For Each D_OBJ In PNL_Row.Controls
            If D_OBJ.Name = index Then
                _activeRow = D_OBJ : Exit For
            End If
        Next
    End Sub

    ''' <summary>
    ''' アクティブセルの取得
    ''' </summary>
    ''' <param name="index"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_ACEL_GET(ByVal index As String) As Control
        Dim D_RTN As Control = Nothing
        '
        If IsNumeric(index) Then
            D_RTN = CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ACEL_GET
        End If
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' アクティブセル名称の取得
    ''' </summary>
    ''' <param name="index"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_ACEL_KEY_GET(ByVal index As String) As String
        Dim D_RTN As String = ""
        Dim D_ACTL As Control = Nothing
        '
        D_ACTL = FNC_ACEL_GET(index)
        '
        If Not IsNothing(D_ACTL) Then
            D_RTN = D_ACTL.Name
        End If
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' アクティブセルの設定
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <remarks></remarks>
    Private Sub FNC_ACEL_SET(ByVal index As String, ByVal cellName As String)
        CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ACEL_SET(cellName)
    End Sub

    ''' <summary>
    ''' セルのテキストを設定
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <remarks></remarks>
    Private Sub FNC_ITM_SET(ByVal index As String, ByVal cellName As String, ByVal value As String)
        '
        CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_SET(cellName, value)
    End Sub

    ''' <summary>
    ''' コンボボックスセルの値を設定
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Private Sub FNC_ITM_CMB_SET(ByVal index As String, ByVal cellName As String, ByVal value As String)
        '
        CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_CMB_SET(cellName, value)
    End Sub

    ''' <summary>
    ''' チェックボックスセルの値を設定
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Private Sub FNC_ITM_CHK_SET(ByVal index As String, ByVal cellName As String, ByVal value As Boolean)
        '
        CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_CHK_SET(cellName, value)
    End Sub

    ''' <summary>
    ''' ラジオボタンセルの値を設定
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <param name="value"></param>
    ''' <remarks></remarks>
    Private Sub FNC_ITM_RDO_SET(ByVal index As String, ByVal cellName As String, ByVal value As Boolean)
        '
        CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_RDO_SET(cellName, value)
    End Sub

    ''' <summary>
    ''' セルのテキストを取得
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_ITM_GET(ByVal index As String, ByVal cellName As String) As String
        Dim D_RTN As String = Nothing
        '
        D_RTN = CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_GET(cellName)
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' コンボボックスセルの値を取得
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_ITM_CMB_GET(ByVal index As String, ByVal cellName As String) As String
        Dim D_RTN As String = Nothing
        '
        D_RTN = CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_CMB_GET(cellName)
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' チェックボックスセルの値を取得
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_ITM_CHK_GET(ByVal index As String, ByVal cellName As String) As Boolean
        Dim D_RTN As Boolean = Nothing
        '
        D_RTN = CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_CHK_GET(cellName)
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' ラジオボタンセルの値を取得
    ''' </summary>
    ''' <param name="index"></param>
    ''' <param name="cellName"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Function FNC_ITM_RDO_GET(ByVal index As String, ByVal cellName As String) As Boolean
        Dim D_RTN As Boolean = Nothing
        '
        D_RTN = CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_ITM_RDO_GET(cellName)
        '
        Return D_RTN
    End Function

    Private Function FNC_ITM_FOT_GET(ByVal cellName As String) As String
        Dim D_RTN As String = Nothing
        '
        D_RTN = UTL_Com.FindControl(Me, cellName).Text
        '
        Return D_RTN
    End Function

    ''' <summary>
    ''' テンプレートの設定
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FNC_SET_TMP()
        '
        Dim I As Integer = Nothing
        Dim D_ROW As Control = Nothing
        '
        For Each D_OBJ In PNL_Designer.Controls
            template = D_OBJ
            Exit For
        Next
        '
        For I = 0 To _maxMrow - 1
            '参考：http://bbs.wankuma.com/index.cgi?mode=al2&namber=68174
            D_ROW = DirectCast(template.GetType.GetConstructor(Type.EmptyTypes).Invoke(Nothing), Control)
            D_ROW.Name = CStr(I)
            PNL_Row.Controls.Add(D_ROW)
        Next
    End Sub

#End Region

#Region "メソッド（公開）"

    Public Sub ComboListSet(ByVal index As String, ByVal cellName As String, _
                            ByVal table As DataTable, ByVal displayMember As String, ByVal valueMember As String)
        If IsNumeric(index) Then
            CType(UTL_Com.FindControl(Me, index), Row130923B).FNC_CMB_LST_SET(cellName, table, displayMember, valueMember)
        End If
    End Sub

    Public Sub DeleteRow(ByVal index As String)
        PNL_Row.SuspendLayout()
        '
        '指定行のコントロールを削除
        PNL_Row.Controls.Remove(CType(UTL_Com.FindControl(Me, CStr(index)), Row130923B))
        '
        'リネーム＆タブ順変更
        For i = CLng(index) + 1 To _maxMrow - 1
            CType(UTL_Com.FindControl(Me, CStr(i)), Row130923B).TabIndex = i - 1
            CType(UTL_Com.FindControl(Me, CStr(i)), Row130923B).Name = CStr(i - 1)
        Next
        '
        _maxMrow -= 1
        '
        PNL_Row.ResumeLayout()
    End Sub

    ''' <summary>
    ''' 行の挿入
    ''' </summary>
    ''' <param name="index"></param>
    ''' <remarks></remarks>
    Public Sub InsertRow(ByVal index As String)
        Dim i As Integer = Nothing
        Dim D_ROW As Object = Nothing
        '
        PNL_Row.SuspendLayout()
        '
        '既存の明細コントロールをリネーム（+1する）＆タブ順変更。※大きい順でリネーム
        For i = _maxMrow - 1 To CLng(index) Step -1
            CType(UTL_Com.FindControl(Me, CStr(i)), Row130923B).TabIndex = i + 1
            CType(UTL_Com.FindControl(Me, CStr(i)), Row130923B).Name = CStr(i + 1)
        Next
        '
        '明細コントロール1個追加
        D_ROW = DirectCast(template.GetType.GetConstructor(Type.EmptyTypes).Invoke(Nothing), Control)
        D_ROW.TabIndex = index
        D_ROW.Name = CStr(index)
        PNL_Row.Controls.Add(D_ROW)
        '
        '指定行にコントロールを移動させる
        PNL_Row.Controls.SetChildIndex(CType(UTL_Com.FindControl(Me, CStr(index)), Row130923B), index)
        '
        _maxMrow += 1
        '
        PNL_Row.ResumeLayout()
    End Sub

#End Region

#Region "イベント"

#End Region

#Region "ActiveControlChangedイベント & CellClickイベント"
    '参考(ActiveControlChangedイベント)：http://blogs.wankuma.com/jeanne/archive/2007/04/02/69804.aspx
    '参考(CellClickイベント)：http://okwave.jp/qa/q1052988.html

    Public Event CellClick(ByVal activeRow As String, ByVal sender As Control, ByVal e As System.EventArgs)

    Private Sub ChildControls_CellTextChanged(ByVal sender As Object, ByVal e As System.EventArgs)
        If TypeName(sender) <> "MrcNumber" Then Exit Sub
        '
        Dim D_SUM_CTL(0) As Control
        '
        '集計値を求めるコントロールを探す(ヘッダー)
        For Each D_CTL As Control In PNL_Header.Controls
            If TypeName(D_CTL) = "MrcNumber" AndAlso _
               DirectCast(D_CTL, UserControls.MrcNumber).CellMateName <> "" AndAlso _
               DirectCast(D_CTL, UserControls.MrcNumber).Summary = True Then
                D_SUM_CTL(D_SUM_CTL.Length - 1) = D_CTL
                ReDim Preserve D_SUM_CTL(D_SUM_CTL.Length)
            End If
        Next
        '集計値を求めるコントロールを探す(フッター)
        For Each D_CTL As Control In PNL_Footer.Controls
            If TypeName(D_CTL) = "MrcNumber" AndAlso _
               DirectCast(D_CTL, UserControls.MrcNumber).CellMateName <> "" AndAlso _
               DirectCast(D_CTL, UserControls.MrcNumber).Summary = True Then
                D_SUM_CTL(D_SUM_CTL.Length - 1) = D_CTL
                ReDim Preserve D_SUM_CTL(D_SUM_CTL.Length)
            End If
        Next
        '
        Dim D_SUM As Decimal = 0
        Dim D_TXT As String = ""
        '
        '集計値の取得・代入
        For Each D_CTL As Control In D_SUM_CTL
            If Not IsNothing(D_CTL) Then
                D_SUM = 0
                For D_I As Integer = 0 To _maxMrow - 1
                    D_TXT = CType(UTL_Com.FindControl(Me, D_I), Row130923B).FNC_ITM_GET(DirectCast(D_CTL, UserControls.MrcNumber).CellMateName)
                    If IsNumeric(D_TXT) Then
                        D_SUM += CDec(D_TXT)
                    End If
                Next
                DirectCast(D_CTL, UserControls.MrcNumber).Text = D_SUM.ToString(DirectCast(D_CTL, UserControls.MrcNumber).DisplayFormat)
            End If
        Next

    End Sub

    Private Sub ChildControls_Enter(ByVal sender As Object, ByVal e As System.EventArgs)
        If sender Is Nothing Then
            Return
        End If

        If Not TypeOf sender Is System.Windows.Forms.Control Then
            Return
        End If
        '
        Dim cControl As System.Windows.Forms.Control = DirectCast(sender, System.Windows.Forms.Control)
        '
        If cControl.Name = "PNL_Row" AndAlso Not IsNothing(_activeRow) Then
            CType(_activeRow, Row130923B).FNC_FST_ENT_MROW()
        ElseIf IsNumeric(cControl.Name) Then
            _activeRow = cControl
        End If
    End Sub

    Private Sub ChildControls_CellClick(ByVal sender As Object, ByVal e As System.EventArgs)
        RaiseEvent CellClick(_activeRow.Name, sender, e)
    End Sub

    Private Sub ChildControls_ControlAdded(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlAdded
        If e Is Nothing Then
            Return
        End If

        If e.Control Is Nothing Then
            Return
        End If
        '
        AddHandler e.Control.ControlAdded, AddressOf ChildControls_ControlAdded
        AddHandler e.Control.ControlRemoved, AddressOf ChildControls_ControlRemoved
        AddHandler e.Control.Enter, AddressOf ChildControls_Enter
        'MultiRowカスタムイベント
        If IsNumeric(e.Control.Name) Then
            AddHandler CType(e.Control, Row130923B).CellClick, AddressOf ChildControls_CellClick
            AddHandler CType(e.Control, Row130923B).CellTextChanged, AddressOf ChildControls_CellTextChanged
        End If
    End Sub

    Private Sub ChildControls_ControlRemoved(ByVal sender As Object, ByVal e As System.Windows.Forms.ControlEventArgs) Handles Me.ControlRemoved
        If e Is Nothing Then
            Return
        End If

        If e.Control Is Nothing Then
            Return
        End If
        '
        RemoveHandler e.Control.ControlAdded, AddressOf ChildControls_ControlAdded
        RemoveHandler e.Control.ControlRemoved, AddressOf ChildControls_ControlRemoved
        RemoveHandler e.Control.Enter, AddressOf ChildControls_Enter
        'MultiRowカスタムイベント
        If IsNumeric(e.Control.Name) Then
            RemoveHandler CType(e.Control, Row130923B).CellClick, AddressOf ChildControls_CellClick
            RemoveHandler CType(e.Control, Row130923B).CellTextChanged, AddressOf ChildControls_CellTextChanged
        End If
    End Sub

#End Region

End Class
